// This autogenerated skeleton file illustrates how to build a server.
// You should copy it to another filename to avoid overwriting it.

#include "AddrBook.h"
#include <thrift/protocol/TBinaryProtocol.h>
#include <thrift/server/TSimpleServer.h>
#include <thrift/transport/TServerSocket.h>
#include <thrift/transport/TBufferTransports.h>

#include <map>

using namespace ::apache::thrift;
using namespace ::apache::thrift::protocol;
using namespace ::apache::thrift::transport;
using namespace ::apache::thrift::server;

using boost::shared_ptr;

class AddrBookHandler : virtual public AddrBookIf {
 public:
  std::map<std::string, std::string> _items;
  
  AddrBookHandler() {
    // Your initialization goes here
  }

  bool add(const std::string& name, const std::string& no) {
    printf("add\n");
    _items[name] = no;
    return true;
  }

  void get(std::string& _return, const std::string& name) {
    printf("get\n");
    std::map<std::string , std::string>::iterator r;
    r = _items.find(name);
    if(r == _items.end()) {
      AddrNotFoundException ouch;
      ouch.msg = name;
      throw ouch;
    }
    _return = (*r).second;
  }

};

int main(int argc, char **argv) {
  int port = 9090;
  shared_ptr<AddrBookHandler> handler(new AddrBookHandler());
  shared_ptr<TProcessor> processor(new AddrBookProcessor(handler));
  shared_ptr<TServerTransport> serverTransport(new TServerSocket(port));
  shared_ptr<TTransportFactory> transportFactory(new TBufferedTransportFactory());
  shared_ptr<TProtocolFactory> protocolFactory(new TBinaryProtocolFactory());

  TSimpleServer server(processor, serverTransport, transportFactory, protocolFactory);
  server.serve();
  return 0;
}

